diff --git a/krita/image/kis_image.cc b/krita/image/kis_image.cc
index aba8a01..3924880 100644
--- a/krita/image/kis_image.cc
+++ b/krita/image/kis_image.cc
@@ -350,67 +350,42 @@ void KisImage::notifyLayerUpdated(KisLayerSP layer)
     }
 }
 
-
-void KisImage::resize(const QRect& rc, bool cropLayers)
+void KisImage::setSize(const QSize& size)
 {
-    resize(rc.width(), rc.height(), rc.x(), rc.y(), cropLayers);
+    m_d->width = size.width();
+    m_d->height = size.height();
+    emitSizeChanged();
 }
 
-void KisImage::resize(qint32 w, qint32 h, qint32 x, qint32 y, bool cropLayers)
+void KisImage::resize(const QRect& newRect, bool cropLayers)
 {
-    if (w != width() || h != height()) {
-
-        if (undo()) {
-            if (cropLayers)
-                m_d->adapter->beginMacro(i18n("Crop Image"));
-            else
-                m_d->adapter->beginMacro(i18n("Resize Image"));
+    if(newRect == bounds())
+        return;
 
-            m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), true));
-            m_d->adapter->addCommand(new KisImageResizeCommand(KisImageWSP(this), w, h, width(), height()));
-        }
+    QString macroName = cropLayers ? i18n("Crop Image") : i18n("Resize Image");
+    m_d->adapter->beginMacro(macroName);
+    m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), true));
+    m_d->adapter->addCommand(new KisImageResizeCommand(KisImageWSP(this), newRect.size()));
 
-        m_d->width = w;
-        m_d->height = h;
+    if(cropLayers) {
+        KisCropVisitor visitor(newRect, m_d->adapter);
+        m_d->rootLayer->accept(visitor);
+    }
 
-        if (cropLayers) {
-            KisCropVisitor v(QRect(x, y, w, h), m_d->adapter);
-            m_d->rootLayer->accept(v);
-        }
+    m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), false));
+    m_d->adapter->endMacro();
 
-        emitSizeChanged();
+    setModified();
+}
 
-        if (undo()) {
-            m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), false));
-            m_d->adapter->endMacro();
-        }
-    }
+void KisImage::resize(qint32 w, qint32 h, qint32 x, qint32 y, bool cropLayers)
+{
+    resize(QRect(x, y, w, h), cropLayers);
 }
 
 void KisImage::resizeWithOffset(qint32 w, qint32 h, qint32 xOffset, qint32 yOffset)
 {
-    if (w == width() && h == height() && xOffset == 0 && yOffset == 0)
-        return;
-
-    lock();
-    if (undo()) {
-        m_d->adapter->beginMacro(i18n("Size Canvas"));
-        m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), true));
-        m_d->adapter->addCommand(new KisImageResizeCommand(KisImageWSP(this), w, h, width(), height()));
-    }
-
-    KisCropVisitor v(QRect(-xOffset, -yOffset, w, h), m_d->adapter);
-    m_d->rootLayer->accept(v);
-
-    emitSizeChanged();
-
-    unlock();
-
-    if (undo()) {
-        m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), false));
-        m_d->adapter->endMacro();
-    }
-
+    resize(QRect(-xOffset, -yOffset, w, h), true);
 }
 
 void KisImage::emitSizeChanged()
@@ -425,54 +400,28 @@ void KisImage::emitSizeChanged()
 
 void KisImage::scale(double sx, double sy, KoUpdater *progress, KisFilterStrategy *filterStrategy)
 {
-    QStringList list;
-    list << "KisLayer";
-
-    KisCountVisitor visitor(list, KoProperties());
-    m_d->rootLayer->accept(visitor);
-
-    if (visitor.count() == 0) return; // Nothing to scale
-
     // New image size. XXX: Pass along to discourage rounding errors?
     qint32 w, h;
     w = (qint32)((width() * sx) + 0.5);
     h = (qint32)((height() * sy) + 0.5);
 
-    if (w != width() || h != height()) {
-
-        lock();
-
-        if (undo()) {
-            m_d->adapter->beginMacro(i18n("Scale Image"));
-            m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), true));
-        }
-
-        {
-            KisTransformVisitor visitor(KisImageWSP(this), sx, sy, 0.0, 0.0, 0.0, 0, 0, progress, filterStrategy);
-            m_d->rootLayer->accept(visitor);
-        }
-
-        if (undo()) {
-            m_d->adapter->addCommand(new KisImageResizeCommand(KisImageWSP(this), w, h, width(), height()));
-        }
+    QSize newSize(w, h);
+    if(newSize == size()) return;
 
-        m_d->width = w;
-        m_d->height = h;
+    m_d->adapter->beginMacro(i18n("Scale Image"));
+    m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), true));
+    m_d->adapter->addCommand(new KisImageResizeCommand(KisImageWSP(this), newSize));
 
-        emitSizeChanged();
+    KisTransformVisitor visitor(KisImageWSP(this), sx, sy, 0.0, 0.0, 0.0, 0, 0, progress, filterStrategy);
+    m_d->rootLayer->accept(visitor);
 
-        unlock();
+    m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), false));
+    m_d->adapter->endMacro();
 
-        if (undo()) {
-            m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), false));
-            m_d->adapter->endMacro();
-        }
-    }
+    setModified();
 }
 void KisImage::rotate(double radians, KoUpdater *progress)
 {
-    lock();
-
     qint32 w = width();
     qint32 h = height();
     qint32 tx = qint32((w * cos(radians) - h * sin(radians) - w) / 2 + 0.5);
@@ -483,28 +432,19 @@ void KisImage::rotate(double radians, KoUpdater *progress)
     tx -= (w - width()) / 2;
     ty -= (h - height()) / 2;
 
-    if (undo()) {
-        m_d->adapter->beginMacro(i18n("Rotate Image"));
-        m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), true));
-    }
+    m_d->adapter->beginMacro(i18n("Rotate Image"));
+    m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), true));
+    m_d->adapter->addCommand(new KisImageResizeCommand(KisImageWSP(this), QSize(w,h)));
 
     KisFilterStrategy *filter = KisFilterStrategyRegistry::instance()->value("Triangle");
+
     KisTransformVisitor visitor(KisImageWSP(this), 1.0, 1.0, 0, 0, radians, -tx, -ty, progress, filter);
     m_d->rootLayer->accept(visitor);
 
-    if (undo()) m_d->adapter->addCommand(new KisImageResizeCommand(KisImageWSP(this), w, h, width(), height()));
-
-    m_d->width = w;
-    m_d->height = h;
-
-    emitSizeChanged();
-
-    unlock();
+    m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), false));
+    m_d->adapter->endMacro();
 
-    if (undo()) {
-        m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), false));
-        m_d->adapter->endMacro();
-    }
+    setModified();
 }
 
 void KisImage::shear(double angleX, double angleY, KoUpdater *progress)
@@ -531,91 +471,89 @@ void KisImage::shear(double angleX, double angleY, KoUpdater *progress)
             h = (qint32)(height() + qAbs(w * tan(angleY * pi / 180)));
     }
 
-    if (w != width() || h != height()) {
+    QSize newSize(w, h);
+    if(newSize == size()) return;
 
-        lock();
+    m_d->adapter->beginMacro(i18n("Shear Image"));
+    m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), true));
+    m_d->adapter->addCommand(new KisImageResizeCommand(KisImageWSP(this), newSize));
 
-        if (undo()) {
-            m_d->adapter->beginMacro(i18n("Shear Image"));
-            m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), true));
-        }
+    KisShearVisitor visitor(angleX, angleY, progress);
+    visitor.setUndoAdapter(m_d->adapter);
+    rootLayer()->accept(visitor);
 
-        KisShearVisitor v(angleX, angleY, progress);
-        v.setUndoAdapter(m_d->adapter);
-        rootLayer()->accept(v);
+    m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), false));
+    m_d->adapter->endMacro();
 
-        if (undo()) m_d->adapter->addCommand(new KisImageResizeCommand(KisImageWSP(this), w, h, width(), height()));
+    setModified();
+}
 
-        m_d->width = w;
-        m_d->height = h;
+void KisImage::convertImageColorSpace(const KoColorSpace *dstColorSpace, KoColorConversionTransformation::Intent renderingIntent)
+{
+    if (*m_d->colorSpace == *dstColorSpace) return;
 
-        emitSizeChanged();
+    m_d->adapter->beginMacro(i18n("Convert Image Color Space"));
+    m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), true));
+    m_d->adapter->addCommand(new KisImageSetProjectionColorSpaceCommand(KisImageWSP(this), dstColorSpace));
 
-        unlock();
+    KisColorSpaceConvertVisitor visitor(this, dstColorSpace, renderingIntent);
+    m_d->rootLayer->accept(visitor);
 
-        if (undo()) {
-            m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), false));
-            m_d->adapter->endMacro();
-        }
-    }
+    m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), false));
+    m_d->adapter->endMacro();
+
+    setModified();
 }
 
-void KisImage::convertTo(const KoColorSpace *dstColorSpace, KoColorConversionTransformation::Intent renderingIntent)
+void KisImage::assignImageProfile(const KoColorProfile *profile)
 {
-    if (*m_d->colorSpace == *dstColorSpace) {
-        return;
-    }
+    if(!profile) return;
 
-    lock();
-
-    const KoColorSpace * oldCs = m_d->colorSpace;
+    m_d->adapter->beginMacro(i18n("Assign Profile"));
+    m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), true));
 
-    if (undo()) {
-        m_d->adapter->beginMacro(i18n("Convert Image Type"));
-        m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), true));
-    }
+    const KoColorSpace *dstCs = KoColorSpaceRegistry::instance()->colorSpace(colorSpace()->colorModelId().id(), colorSpace()->colorDepthId().id(), profile);
+    const KoColorSpace *srcCs = colorSpace();
 
-    KisColorSpaceConvertVisitor visitor(this, dstColorSpace, renderingIntent);
+    KisChangeProfileVisitor visitor(srcCs, dstCs);
     m_d->rootLayer->accept(visitor);
 
-    if (undo()) {
-
-        m_d->adapter->addCommand(new KisImageConvertTypeCommand(KisImageWSP(this), oldCs, dstColorSpace));
-        m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), false));
-        m_d->adapter->endMacro();
-    } else {
-        setColorSpace(dstColorSpace);
-    }
-
-    unlock();
-    refreshGraph();
-}
+    m_d->adapter->addCommand(new KisImageSetProjectionColorSpaceCommand(KisImageWSP(this), dstCs));
+    m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), false));
+    m_d->adapter->endMacro();
 
-const KoColorProfile * KisImage::profile() const
-{
-    return colorSpace()->profile();
+    setModified();
+    emit sigProfileChanged(profile);
 }
 
-void KisImage::setProfile(const KoColorProfile *profile)
+void KisImage::convertProjectionColorSpace(const KoColorSpace *dstColorSpace)
 {
-    if (profile == 0) return;
+    if (*m_d->colorSpace == *dstColorSpace) return;
 
-    kDebug() << profile;
-
-    const KoColorSpace *dstCs = KoColorSpaceRegistry::instance()->colorSpace(colorSpace()->colorModelId().id(), colorSpace()->colorDepthId().id(), profile);
-    if (dstCs) {
+    m_d->adapter->beginMacro(i18n("Convert Projection Color Space"));
+    m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), true));
+    m_d->adapter->addCommand(new KisImageSetProjectionColorSpaceCommand(KisImageWSP(this), dstColorSpace));
+    m_d->adapter->addCommand(new KisImageLockCommand(KisImageWSP(this), false));
+    m_d->adapter->endMacro();
 
-        lock();
+    setModified();
+}
 
-        const KoColorSpace *oldCs = colorSpace();
-        setColorSpace(dstCs);
-        emit(sigProfileChanged(const_cast<KoColorProfile*>(profile)));
+void KisImage::setProjectionColorSpace(const KoColorSpace * colorSpace)
+{
+    m_d->colorSpace = colorSpace;
+    m_d->rootLayer->resetCache();
+    emit sigColorSpaceChanged(colorSpace);
+}
 
-        KisChangeProfileVisitor visitor(oldCs, dstCs);
-        m_d->rootLayer->accept(visitor);
+const KoColorSpace * KisImage::colorSpace() const
+{
+    return m_d->colorSpace;
+}
 
-        unlock();
-    }
+const KoColorProfile * KisImage::profile() const
+{
+    return colorSpace()->profile();
 }
 
 double KisImage::xRes() const
@@ -738,16 +676,14 @@ void KisImage::flatten()
         new KisPaintLayer(this, nextLayerName(), OPACITY_OPAQUE_U8, projectionCopy);
     Q_CHECK_PTR(flattenLayer);
 
-    m_d->adapter->beginMacro(i18n("Flatten Image"));
-    m_d->adapter->addCommand(new KisImageChangeLayersCommand(KisImageWSP(this), oldRootLayer, newRootLayer, ""));
-
     addNode(flattenLayer, newRootLayer, 0);
 
-    // notify once again to be sure tools have set
-    // their current paint devices
-    notifyLayersChanged();
-
+    m_d->adapter->beginMacro(i18n("Flatten Image"));
+    // NOTE: KisImageChangeLayersCommand performs all the locking for us
+    m_d->adapter->addCommand(new KisImageChangeLayersCommand(KisImageWSP(this), oldRootLayer, newRootLayer, ""));
     m_d->adapter->endMacro();
+
+    setModified();
 }
 
 // FIXME: Rename to Merge Down?
@@ -777,7 +713,6 @@ KisLayerSP KisImage::mergeLayer(KisLayerSP layer, const KisMetaData::MergeStrate
     KisPaintLayerSP mergedLayer = new KisPaintLayer(this, prevLayer->name(), OPACITY_OPAQUE_U8, mergedDevice);
     Q_CHECK_PTR(mergedLayer);
 
-
     // Merge meta data
     QList<const KisMetaData::Store*> srcs;
     srcs.append(prevLayer->metaData());
@@ -811,7 +746,13 @@ KisLayerSP KisImage::flattenLayer(KisLayerSP layer)
 
     undoAdapter()->beginMacro(i18n("Flatten Layer"));
 
+    /**
+     * Make the copy operation synchronous
+     */
+    lock();
     KisPaintDeviceSP mergedDevice = new KisPaintDevice(*layer->projection());
+    unlock();
+
     KisPaintLayerSP newLayer = new KisPaintLayer(this, layer->name(), layer->opacity(), mergedDevice);
     newLayer->setCompositeOp(layer->compositeOp()->id());
 
@@ -1024,23 +965,6 @@ KisActionRecorder* KisImage::actionRecorder() const
     return m_d->recorder;
 }
 
-bool KisImage::undo() const
-{
-    return (m_d->adapter && m_d->adapter->undo());
-}
-
-const KoColorSpace * KisImage::colorSpace() const
-{
-    return m_d->colorSpace;
-}
-
-void KisImage::setColorSpace(const KoColorSpace * colorSpace)
-{
-    m_d->colorSpace = colorSpace;
-    m_d->rootLayer->resetCache();
-    emit sigColorSpaceChanged(colorSpace);
-}
-
 void KisImage::setRootLayer(KisGroupLayerSP rootLayer)
 {
     if(m_d->rootLayer)
diff --git a/krita/image/kis_image.h b/krita/image/kis_image.h
index e83af97..744c55b 100644
--- a/krita/image/kis_image.h
+++ b/krita/image/kis_image.h
@@ -233,20 +233,29 @@ public:
     /**
      * Convert the image and all its layers to the dstColorSpace
      */
-    void convertTo(const KoColorSpace * dstColorSpace, KoColorConversionTransformation::Intent renderingIntent = KoColorConversionTransformation::IntentPerceptual);
+    void convertImageColorSpace(const KoColorSpace *dstColorSpace, KoColorConversionTransformation::Intent renderingIntent = KoColorConversionTransformation::IntentPerceptual);
+
+    /**
+     * Set the color space of  the projection (and the root layer)
+     * to dstColorSpace. No conversion is done for other layers,
+     * their colorspace can differ.
+     * NOTE: Note conversion is done, only regeneration, so no rendering
+     * intent needed
+     */
+    void convertProjectionColorSpace(const KoColorSpace *dstColorSpace);
 
     // Get the profile associated with this image
     const KoColorProfile *  profile() const;
 
     /**
      * Set the profile of the image to the new profile and do the same for
-     * all layers that have the same colorspace and profile as the image.
+     * all layers that have the same colorspace and profile of the image.
      * It doesn't do any pixel conversion.
      *
      * This is essential if you have loaded an image that didn't
      * have an embedded profile to which you want to attach the right profile.
      */
-    void setProfile(const KoColorProfile * profile);
+    void assignImageProfile(const KoColorProfile *profile);
 
     /**
      * Replace the current undo adapter with the specified undo adapter.
@@ -266,11 +275,6 @@ public:
     KisActionRecorder* actionRecorder() const;
 
     /**
-     * Returns true if this image wants undo information, false otherwise
-     */
-    bool undo() const;
-
-    /**
      * Tell the image it's modified; this emits the sigImageModified
      * signal. This happens when the image needs to be saved
      */
@@ -433,8 +437,6 @@ public:
     */
     void notifyLayerUpdated(KisLayerSP layer);
 
-    void setColorSpace(const KoColorSpace * colorSpace);
-
     void setRootLayer(KisGroupLayerSP rootLayer);
 
     /**
@@ -490,7 +492,7 @@ signals:
     void sigImageModified();
 
     void sigSizeChanged(qint32 w, qint32 h);
-    void sigProfileChanged(KoColorProfile *  profile);
+    void sigProfileChanged(const KoColorProfile *  profile);
     void sigColorSpaceChanged(const KoColorSpace*  cs);
     void sigResolutionChanged(double xRes, double yRes);
 
@@ -540,6 +542,11 @@ private:
     void emitSizeChanged();
     void preparePaintLayerAfterAdding(KisLayerSP layer);
 
+    friend class KisImageResizeCommand;
+    void setSize(const QSize& size);
+
+    friend class KisImageSetProjectionColorSpaceCommand;
+    void setProjectionColorSpace(const KoColorSpace * colorSpace);
 private:
     class KisImagePrivate;
     KisImagePrivate * const m_d;
diff --git a/krita/image/kis_paint_device.cc b/krita/image/kis_paint_device.cc
index 7b01a0c..b3758bd 100644
--- a/krita/image/kis_paint_device.cc
+++ b/krita/image/kis_paint_device.cc
@@ -374,21 +374,20 @@ QRect KisPaintDevice::exactBounds() const
 
 void KisPaintDevice::crop(qint32 x, qint32 y, qint32 w, qint32 h)
 {
-    m_datamanager->setExtent(x - m_d->x, y - m_d->y, w, h);
+    crop(QRect(x, y, w, h));
 }
 
 
-void KisPaintDevice::crop(const QRect & r)
+void KisPaintDevice::crop(const QRect &rect)
 {
-    QRect rc(r);
-    rc.translate(-m_d->x, -m_d->y);
-    m_datamanager->setExtent(rc);
+    m_datamanager->setExtent(rect.translated(-m_d->x, -m_d->y));
+    m_d->cache.invalidate();
 }
 
 void KisPaintDevice::setDefaultPixel(const quint8 *defPixel)
 {
-    m_d->cache.invalidate();
     m_datamanager->setDefaultPixel(defPixel);
+    m_d->cache.invalidate();
 }
 
 const quint8 *KisPaintDevice::defaultPixel() const
@@ -398,21 +397,21 @@ const quint8 *KisPaintDevice::defaultPixel() const
 
 void KisPaintDevice::clear()
 {
-    m_d->cache.invalidate();
     m_datamanager->clear();
+    m_d->cache.invalidate();
 }
 
 void KisPaintDevice::fill(qint32 x, qint32 y, qint32 w, qint32 h, const quint8 *fillPixel)
 {
-    m_d->cache.invalidate();
     m_datamanager->clear(x, y, w, h, fillPixel);
+    m_d->cache.invalidate();
 }
 
 
 void KisPaintDevice::clear(const QRect & rc)
 {
-    m_d->cache.invalidate();
     m_datamanager->clear(rc.x(), rc.y(), rc.width(), rc.height(), m_datamanager->defaultPixel());
+    m_d->cache.invalidate();
 }
 
 bool KisPaintDevice::write(KoStore *store)
@@ -425,10 +424,10 @@ bool KisPaintDevice::write(KoStore *store)
 
 bool KisPaintDevice::read(KoStore *store)
 {
-    m_d->cache.invalidate();
     bool retval = m_datamanager->read(store);
-    emit ioProgress(100);
+    m_d->cache.invalidate();
 
+    emit ioProgress(100);
     return retval;
 }
 
diff --git a/krita/image/kis_painter.cc b/krita/image/kis_painter.cc
index 27fe4dd..b291d67 100644
--- a/krita/image/kis_painter.cc
+++ b/krita/image/kis_painter.cc
@@ -156,9 +156,10 @@ void KisPainter::init()
 
 KisPainter::~KisPainter()
 {
-    QUndoCommand* cmd = end();
-    Q_ASSERT(cmd == 0);
-    delete cmd;
+    // TODO: Maybe, don't be that strict?
+    // deleteTransaction();
+    end();
+
     delete d->paintOp;
     delete d->maskPainter;
     delete d->fillPainter;
@@ -176,43 +177,67 @@ void KisPainter::begin(KisPaintDeviceSP device, KisSelectionSP selection)
     d->selection = selection;
     Q_ASSERT(device->colorSpace());
 
-    delete d->transaction;
-    d->transaction = 0;
+    end();
 
     d->device = device;
     d->colorSpace = device->colorSpace();
     d->compositeOp = d->colorSpace->compositeOp(COMPOSITE_OVER);
     d->pixelSize = device->pixelSize();
 }
-QUndoCommand *KisPainter::end()
+
+void KisPainter::end()
 {
-    return endTransaction();
+    Q_ASSERT_X(!d->transaction, "KisPainter::end()",
+               "end() was called for the painter having a transaction. "
+               "Please use end/deleteTransaction() instead");
 }
 
-void KisPainter::beginTransaction(const QString& customName)
+void KisPainter::beginTransaction(const QString& transactionName)
 {
-    delete d->transaction;
-    d->transaction = new KisTransaction(customName, d->device);
+    Q_ASSERT_X(!d->transaction, "KisPainter::beginTransaction()",
+               "You asked for a new transaction while still having "
+               "another one. Please finish the first one with "
+               "end/deleteTransaction() first");
+
+    d->transaction = new KisTransaction(transactionName, d->device);
     Q_CHECK_PTR(d->transaction);
 }
 
-void KisPainter::beginTransaction(KisTransaction* command)
+void KisPainter::endTransaction(KisUndoAdapter *undoAdapter)
 {
+    Q_ASSERT_X(d->transaction, "KisPainter::endTransaction()",
+               "No transaction is in progress");
+
+    d->transaction->commit(undoAdapter);
     delete d->transaction;
-    d->transaction = command;
+    d->transaction = 0;
 }
 
+void KisPainter::deleteTransaction()
+{
+    if (!d->transaction) return;
 
-QUndoCommand* KisPainter::endTransaction()
+    delete d->transaction;
+    d->transaction = 0;
+}
+
+void KisPainter::putTransaction(KisTransaction* transaction)
 {
-    if (!d->transaction) return 0;
+    Q_ASSERT_X(!d->transaction, "KisPainter::putTransaction()",
+               "You asked for a new transaction while still having "
+               "another one. Please finish the first one with "
+               "end/deleteTransaction() first");
 
-    if (d->device)
-        d->device->disconnect(d->transaction);
+    d->transaction = transaction;
+}
 
-    QUndoCommand *command = d->transaction;
+KisTransaction* KisPainter::takeTransaction()
+{
+    Q_ASSERT_X(d->transaction, "KisPainter::takeTransaction()",
+               "No transaction is in progress");
+    KisTransaction *temp = d->transaction;
     d->transaction = 0;
-    return command;
+    return temp;
 }
 
 QRegion KisPainter::dirtyRegion()
diff --git a/krita/image/kis_painter.h b/krita/image/kis_painter.h
index 84a8195..3809bde 100644
--- a/krita/image/kis_painter.h
+++ b/krita/image/kis_painter.h
@@ -42,6 +42,7 @@ class KoUpdater;
 class KoColor;
 class KoCompositeOp;
 
+class KisUndoAdapter;
 class KisTransaction;
 class KisPattern;
 class KisFilterConfiguration;
@@ -93,7 +94,7 @@ public:
     /**
      * Finish painting on the current device
      */
-    QUndoCommand *end();
+    void end();
 
     /**
      * If set, the painter action is cancelable, if the action supports that.
@@ -101,13 +102,23 @@ public:
     void setProgress(KoUpdater * progressUpdater);
 
     /// Begin an undoable paint operation
-    void beginTransaction(const QString& customName = "");
+    void beginTransaction(const QString& transactionName = "");
 
     /// Finish the undoable paint operation
-    QUndoCommand *endTransaction();
+    void endTransaction(KisUndoAdapter *undoAdapter);
 
-    /// begin a transaction with the given command
-    void beginTransaction(KisTransaction* command);
+    /**
+     * Finish the transaction and delete it's undo information.
+     * NOTE: Be careful, because all the previous transactions
+     * will become non-undoable after execution of this method.
+     */
+    void deleteTransaction();
+
+    /// continue a transaction started somewhere else
+    void putTransaction(KisTransaction* transaction);
+
+    /// take transaction out of the reach of KisPainter
+    KisTransaction* takeTransaction();
 
     /// Returns the current paint device.
     const KisPaintDeviceSP device() const;
diff --git a/krita/image/kis_selected_transaction_data.cpp b/krita/image/kis_selected_transaction_data.cpp
new file mode 100644
index 0000000..5a958f0
--- /dev/null
+++ b/krita/image/kis_selected_transaction_data.cpp
@@ -0,0 +1,105 @@
+/*
+ *  Copyright (c) 2002 Patrick Julien <freak@codepimps.org>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+
+#include "kis_selected_transaction_data.h"
+
+#include "kis_selection.h"
+#include "kis_pixel_selection.h"
+#include "kis_image.h"
+#include "kis_layer.h"
+#include "kis_undo_adapter.h"
+
+KisSelectedTransactionData::KisSelectedTransactionData(const QString& name, KisNodeSP node, QUndoCommand* parent)
+        : KisTransactionData(name, node->paintDevice(), parent)
+        , m_selTransaction(0)
+        , m_hadSelection(false /*device->hasSelection()*/)
+{
+    m_layer = dynamic_cast<KisLayer*>(node.data());
+    while (!m_layer && node->parent()) {
+        m_layer = dynamic_cast<KisLayer*>(node->parent().data());
+        node = node->parent();
+    }
+
+    if (m_layer->selection())
+        m_selTransaction = new KisTransactionData(name, KisPaintDeviceSP(m_layer->selection()->getOrCreatePixelSelection().data()));
+//     if(! m_hadSelection) {
+//         m_device->deselect(); // let us not be the cause of select
+//     }
+}
+
+KisSelectedTransactionData::~KisSelectedTransactionData()
+{
+    delete m_selTransaction;
+}
+
+void KisSelectedTransactionData::redo()
+{
+    // Both transactions will block on the first redo
+    KisTransactionData::redo();
+
+    if (m_selTransaction)
+        m_selTransaction->redo();
+//     if(m_redoHasSelection)
+//         m_device->selection();
+//     else
+//         m_device->deselect();
+
+    m_layer->setDirty(m_layer->image()->bounds());
+    m_layer->image()->undoAdapter()->emitSelectionChanged();
+}
+
+void KisSelectedTransactionData::undo()
+{
+//     m_redoHasSelection = m_device->hasSelection();
+
+    KisTransactionData::undo();
+
+    if (m_selTransaction)
+        m_selTransaction->undo();
+//     if(m_hadSelection)
+//         m_device->selection();
+//     else
+//         m_device->deselect();
+//
+    m_layer->setDirty(m_layer->image()->bounds());
+    m_layer->image()->undoAdapter()->emitSelectionChanged();
+}
+
+void KisSelectedTransactionData::undoNoUpdate()
+{
+//     m_redoHasSelection = m_device->hasSelection();
+//
+//     KisTransactionData::undoNoUpdate();
+//     m_selTransaction->undoNoUpdate();
+//     if(m_hadSelection)
+//         m_device->selection();
+//     else
+//         m_device->deselect();
+}
+
+void KisSelectedTransactionData::endTransaction()
+{
+    KisTransactionData::endTransaction();
+    if(m_selTransaction)
+        m_selTransaction->endTransaction();
+}
+
+KisLayerSP KisSelectedTransactionData::layer()
+{
+    return m_layer;
+}
diff --git a/krita/image/kis_selected_transaction_data.h b/krita/image/kis_selected_transaction_data.h
new file mode 100644
index 0000000..4d97253
--- /dev/null
+++ b/krita/image/kis_selected_transaction_data.h
@@ -0,0 +1,57 @@
+/*
+ *  Copyright (c) 2005 Casper Boemann <cbr@boemann.dk>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+
+#ifndef KIS_SELECTED_TRANSACTION_DATA_H_
+#define KIS_SELECTED_TRANSACTION_DATA_H_
+
+#include "kis_transaction_data.h"
+
+#include "kis_selection.h"
+
+/**
+ * KisSelectedTransactionData records changes to the selection for the undo stack. There
+ * are two selections in Krita: the global selection and the per-layer selection mask.
+ * A particular action only works with one of these selections (in the future, we may
+ * want to merge the global and local selection).
+ *
+ * KisSelectedTransactionData remembers which selection was changed.
+ */
+class KRITAIMAGE_EXPORT KisSelectedTransactionData : public KisTransactionData
+{
+
+public:
+    KisSelectedTransactionData(const QString& name, KisNodeSP node, QUndoCommand* parent = 0);
+    virtual ~KisSelectedTransactionData();
+
+public:
+    void redo();
+    void undo();
+    void undoNoUpdate();
+protected:
+    void endTransaction();
+
+protected:
+    KisLayerSP layer();
+private:
+    KisLayerSP m_layer;
+    KisTransactionData *m_selTransaction;
+    bool m_hadSelection;
+    bool m_redoHasSelection;
+};
+
+#endif // KIS_SELECTED_TRANSACTION_DATA_H_
diff --git a/krita/image/kis_selection_transaction_data.cpp b/krita/image/kis_selection_transaction_data.cpp
new file mode 100644
index 0000000..3192404
--- /dev/null
+++ b/krita/image/kis_selection_transaction_data.cpp
@@ -0,0 +1,56 @@
+/*
+ *  Copyright (c) 2002 Patrick Julien <freak@codepimps.org>
+ *  Copyright (c) 2008 Sven Langkamp <sven.langkamp@gmail.com>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+
+#include "kis_selection_transaction_data.h"
+
+#include "kis_selection.h"
+#include "kis_pixel_selection.h"
+#include "kis_image.h"
+#include "kis_undo_adapter.h"
+
+KisSelectionTransactionData::KisSelectionTransactionData(const QString& name, KisImageWSP image, KisSelectionSP selection, QUndoCommand* parent) :
+        KisTransactionData(name, selection->getOrCreatePixelSelection().data(), parent)
+        , m_image(image)
+        , m_selection(selection)
+        , m_wasDeselected(selection->isDeselected())
+{
+    if (m_selection->isDeselected()) {
+        m_selection->getOrCreatePixelSelection()->clear();
+        m_selection->setDeselected(false);
+    }
+}
+
+KisSelectionTransactionData::~KisSelectionTransactionData()
+{
+}
+
+void KisSelectionTransactionData::redo()
+{
+    KisTransactionData::redo();
+    m_selection->setDirty(m_image->bounds());
+    m_image->undoAdapter()->emitSelectionChanged();
+}
+
+void KisSelectionTransactionData::undo()
+{
+    KisTransactionData::undo();
+    m_selection->setDirty(m_image->bounds());
+    m_selection->setDeselected(m_wasDeselected);
+    m_image->undoAdapter()->emitSelectionChanged();
+}
